#include "sdk_common.h"
#if NRF_MODULE_ENABLED(BLE_TGOI)
#include "ble_tgoi.h"
#include "ble_srv_common.h"


/**@brief Function for handling the Write event.
 *
 * @param[in] p_lbs      LED Button Service structure.
 * @param[in] p_ble_evt  Event received from the BLE stack.
 */
static void on_write(ble_tgoi_t * p_tgoi, ble_evt_t const * p_ble_evt)
{
    ble_gatts_evt_write_t const * p_evt_write = &p_ble_evt->evt.gatts_evt.params.write;

	  //serverݴΪһݰȣݰǱ仯ģڽʱҪжϼ
	  //гȳжûҪ
	  
    if (   (p_evt_write->handle == p_tgoi->SIMO_char_handles.value_handle)
        //&& (p_evt_write->len == 1)
        && (p_tgoi->SIMO_write_handler != NULL))
    {
			  //յݺĴcall˺µӦӦðܡCRC֤ԺϷݵҵ
        p_tgoi->SIMO_write_handler(p_ble_evt->evt.gap_evt.conn_handle, p_tgoi, (uint8_t*)(p_evt_write->data),p_evt_write->len);
    }
}


//BLE¼Ĵ
//ֻtgoiйص¼ҲserverݰһΪ
//˺ڳʼʱΪݸSDHSDHյBLE¼call˺
void ble_tgoi_on_ble_evt(ble_evt_t const * p_ble_evt, void * p_context)
{
    ble_tgoi_t * p_tgoi = (ble_tgoi_t *)p_context;

    switch (p_ble_evt->header.evt_id)
    {
        case BLE_GATTS_EVT_WRITE:
            on_write(p_tgoi, p_ble_evt);
            break;

        default:
            // No implementation needed.
            break;
    }
}


uint32_t ble_tgoi_init(ble_tgoi_t * p_tgoi, const ble_tgoi_init_t * p_tgoi_init)
{
    uint32_t              err_code;
    ble_uuid_t            ble_uuid;
    ble_add_char_params_t add_char_params;

    // Initialize service structure.
    p_tgoi->SIMO_write_handler = p_tgoi_init->SIMO_write_handler;

    // Add service.
    ble_uuid128_t base_uuid = {TGOI_UUID_BASE};
    err_code = sd_ble_uuid_vs_add(&base_uuid, &p_tgoi->uuid_type);
    VERIFY_SUCCESS(err_code);

    ble_uuid.type = p_tgoi->uuid_type;
    ble_uuid.uuid = TGOI_UUID_SERVICE;

    err_code = sd_ble_gatts_service_add(BLE_GATTS_SRVC_TYPE_PRIMARY, &ble_uuid, &p_tgoi->service_handle);
    VERIFY_SUCCESS(err_code);

    // Add characteristic:SOMI,clientϴ
    memset(&add_char_params, 0, sizeof(add_char_params));
    add_char_params.uuid              = TGOI_UUID_SOMI_CHAR;
    add_char_params.uuid_type         = p_tgoi->uuid_type;
    add_char_params.init_len          = sizeof(uint8_t);
    add_char_params.max_len           = 50;//test only sizeof(uint8_t);
		//ṩݵΪserverһperipheralṩݣΪserverΪserverܽκβ
		//ֻжҪʵclientŻȨơзʵһcenterĽɫΪclient
    add_char_params.char_props.read   = 1;
    add_char_params.char_props.notify = 1;

    add_char_params.read_access       = SEC_OPEN;
    add_char_params.cccd_write_access = SEC_OPEN;

    err_code = characteristic_add(p_tgoi->service_handle,
                                  &add_char_params,
                                  &p_tgoi->SOMI_char_handles);
    if (err_code != NRF_SUCCESS)
    {
        return err_code;
    }

    // Add characteristic: SIMO,Է
    memset(&add_char_params, 0, sizeof(add_char_params));
    add_char_params.uuid             = TGOI_UUID_SIMO_CHAR;
    add_char_params.uuid_type        = p_tgoi->uuid_type;
    add_char_params.init_len         = sizeof(uint8_t);
    add_char_params.max_len          = 50;//test sizeof(uint8_t);
    add_char_params.char_props.read  = 1;
    add_char_params.char_props.write = 1;

    add_char_params.read_access  = SEC_OPEN;
    add_char_params.write_access = SEC_OPEN;

    return characteristic_add(p_tgoi->service_handle, &add_char_params, &p_tgoi->SIMO_char_handles);
}


uint32_t ble_tgoi_on_SOMI_change(uint16_t conn_handle, ble_tgoi_t * p_tgoi, uint8_t* data,uint16_t dataLen)
{
    ble_gatts_hvx_params_t params;
    
    memset(&params, 0, sizeof(params));
    params.type   = BLE_GATT_HVX_NOTIFICATION;
    params.handle = p_tgoi->SOMI_char_handles.value_handle;
    params.p_data = data;
    params.p_len  = &dataLen;

    return sd_ble_gatts_hvx(conn_handle, &params);
}
#endif // NRF_MODULE_ENABLED(BLE_LBS)
